/*************************************************************************************
 Data Visualization - project 2
 Author: Lijuan Cheng
 Supervisor: George Legrady
 
 Usage:
 *************************************************************************************/

import peasy.*;
PeasyCam cam;

Table table1, table2;
int numRows1, numRows2, numColumns, smallest, largest, year, month, day;
int startYear = 2006;
int endYear = 2021;
int[][] counts, radius;
int[] colors;

ArrayList<Book> books = new ArrayList<Book>();

void setup() {
  size(1200, 800, P3D);
  cam = new PeasyCam(this, 200);

  table1 = loadTable("FiveAsianCountriesCounts.csv", "header");
  table2 = loadTable("FiveAsianCountriesBooks.csv", "header");
  numRows1 = table1.getRowCount();
  numRows2 = table2.getRowCount();

  counts = new int[numRows1][5];
  radius = new int[numRows1][5];

  for (int i=0; i<numRows1; i++) {
    //create a 2d array to store the total counts for five countries
    for (int j = 1; j < 6; j++) {
      counts[i][j-1] = table1.getInt(i, j);
      //println(counts[i][j-1]);
    }
    smallest = min(counts[i]);
    largest = max(counts[i]);
    //calculate the radius of the circle
    for (int j = 0; j < 5; j++) {
      radius[i][j] = int(map(counts[i][j], smallest, largest, 30, 150));
      //println(radius[i][j]);
    }
  }

  for (int i=0; i<numRows2; i++) {
    String country = table2.getString(i, 0);
    String bibNumber = table2.getString(i, 1);
    String date = table2.getString(i, 2);
    String title = table2.getString(i, 3);
    int count = table2.getInt(i, 4);
    Book newBook = new Book(country, bibNumber, date, title, count);
    books.add(newBook);
  }
}

void draw() {
  background(0);
  //draw five circles to represent the five countries, the radius value should show the total counts
  pushMatrix();
  int[] colors = {#9933FF, #0000FF, #66FFCC, #FFFF33, #FF0033 };
  for (int year = 2006; year < 2022; year++) {
    int i = year - 2006;

    for (int j = 0; j < 5; j++) {
      stroke(colors[j]);
      strokeWeight(2);
      noFill();
      ellipse(0, 0, radius[i][j], radius[i][j]);
    }
    textSize(15);
    fill(255);
    text (year, 0, 0, 5);
    // move to the next year
    translate (0, 0, -150);
  }
  popMatrix();

  //draw the points in the edge of every circle to represent the books.
  for ( int i = 0; i < books.size(); i++) {
    Book theBook = books.get(i);
    String[] dates = split(theBook.date, '-');
    int year = int(dates[0]);

    //skip to next drawing cycle if the date not meet requirement
    if ( year < 2006 || year > 2021) {
      continue;
      }

      // calculate the book coordinate accroding to the pointCoordinate function
      PVector pCoordinate = pointCoordinate(theBook.country, theBook.date);
      color c = colorDetermine(theBook.country);

      /* calculate the distance between (p_x, p_y) , (mouseX, mouseY) */
      float distanceObjectMouse = sq(pCoordinate.x - mouseX) + sq(pCoordinate.y-mouseY);

      /* draw title if the mouse is near the dots */
      /* if dots is near the mouse, draw it bigger(10) */
      /* else, draw it smaller(2) */

      if (distanceObjectMouse < 20) {
        strokeWeight(10);
      } else {
        strokeWeight(2);
      }

      stroke(c);
      point(pCoordinate.x, pCoordinate.y, pCoordinate.z);
    }
  }
