color colorDetermine(String country){
  color c = #FFFFFF;
  if(country.equals("China")){
    c = #F75F00;
  }
  else if(country.equals("India")){
    c = #00BC56;
  }
  else if(country.equals("Japan")){
    c = #28A4F5;
  }
  else if(country.equals("Korea")){
    c = #F7C200;
  }
  else if(country.equals("Vietnam")){
    c = #EEB422;
  }
  return c;
}

PVector pointCoordinate(String country, String rawDate) {
  float point_x, point_y, point_z;
  String[] dates = split(rawDate, '-');
  int year = int(dates[0]);
  int month = int(dates[1]);
  int day = int(dates[2]);
  
  int i = year - 2006;
  HashMap<String, Integer> map = new HashMap<>();
  map.put("China", 0);
  map.put("India", 1);
  map.put("Japan", 2);
  map.put("Korea", 3);
  map.put("Vietnam", 4);
  int j = map.get(country);
  int r = radius[i][j];

  float degree = (month-1)*30 + day;
  point_x = r * cos(radians(degree));
  point_y = r * sin(radians(degree));
  point_z = -150*i;

  PVector pCoordinate = new PVector(point_x, point_y, point_z);

  return pCoordinate;
}
